
/* ===== pfod Command for LinkIt Led ====
{.<bg n><w><+3>Control LinkIt Led via Bluetooth|A~<+6>LED is `0~~Off\On}
 */
// Using Seeed Studio LinkIt ONE board connecting via Bluetooth
// NOTE: This is experimental. LinkIt ONE stops accepting connections after about 15mins and needs to be reset

/* Code generated by pfodDesigner V1.2.572
 * (c)2014-2015 Forward Computing and Control Pty. Ltd.
 * NSW Australia, www.forward.com.au
 * This generated code may be freely used for both private and commerical use
 */
#include <LBT.h>
#include <LBTServer.h>
// Download library from http://www.forward.com.au/pfod/pfodParserLibraries/index.html
#include <LEEPROM.h>
#include <pfodLinkIt.h>
pfodLinkIt parser; // create a parser to handle the pfod messages
boolean alreadyConnected = false; // whether or not the client was connected previously

// give the board pins names, if you change the pin number here you will change the pin controlled
int cmd_A_pin = 13; // name the output pin for 'LED is '

// the setup routine runs once on reset:
void setup() {
  for (int i=3; i>0; i--) {
    // wait a few secs to see if we are being programmed
    delay(1000);
  }
  //pinMode(cmd_A_pin, INPUT_PULLUP); 
  pinMode(cmd_A_pin, OUTPUT); // output for 'LED is ' is initially LOW, uncomment line above if you want it initially HIGH
   // Serial.begin(9600); // un-comment this for debugging
  bool LBTServerRunning = LBTServer.begin((uint8_t*)"pfodLinkItONE");
  if ( !LBTServerRunning )  {
    // don't do anything else
    while (true) {
  //  Serial.println(F("Cannot begin Bluetooth Server successfully"));
      delay(5000);
    }
  }

  // <<<<<<<<< Your extra setup code goes here
}

// the loop routine runs over and over again forever:
void loop() {
  if (LBTServer.connected() && (!alreadyConnected)) {
    parser.connect(&LBTServer); // sets new io stream to read from and write to
    alreadyConnected = true;
  }

  if (!LBTServer.connected()) {
    if (alreadyConnected) {
      // client closed so clean up
      closeConnection(parser.getPfodAppStream());
    }
    alreadyConnected = false;
    bool connected = LBTServer.accept(1); // fails to connect after <1hr
  } else { // connected 	

      byte cmd = parser.parse(); // pass it to the parser
      // parser returns non-zero when a pfod command is fully parsed
      if (cmd != 0) { // have parsed a complete msg { to }
        byte* pfodFirstArg = parser.getFirstArg(); // may point to \0 if no arguments in this msg.
        long pfodLongRtn; // used for parsing long return arguments, if any
        if ('.' == cmd) {
          // pfodApp has connected and sent {.} , it is asking for the main menu
          // send back the menu designed
          sendMainMenu();

        // now handle commands returned from button/sliders
        } else if('A'==cmd) { // user moved slider -- 'LED is '
          // set output based on slider 0 == LOW, 1 == HIGH
          parser.parseLong(pfodFirstArg,&pfodLongRtn); // parse first arg as a long
          digitalWrite(cmd_A_pin,pfodLongRtn); // set output
          sendMainMenuUpdate(); // always send back a pfod msg otherwise pfodApp will disconnect.

        } else if ('!' == cmd) {
          // CloseConnection command
          closeConnection(parser.getPfodAppStream());
        } else {
          // unknown command
          parser.print(F("{}")); // always send back a pfod msg otherwise pfodApp will disconnect.
        }
      }
  }
  
  //  <<<<<<<<<<<  Your other loop() code goes here 
  
}

void closeConnection(Stream *io) {
  // add any special code here to force connection to be dropped
  parser.closeConnection(); // nulls io stream
}

void sendMainMenu() {
  parser.print(F("{."));  // start a Menu screen pfod message
  send_menuContents(); // send the menu contents
  parser.print(F("}"));  // close pfod message
}

void sendMainMenuUpdate() {
  parser.print(F("{:"));  // start an Update Menu pfod message
  send_menuContents(); // send the menu contents
  parser.print(F("}"));  // close pfod message
}

// modify this method if you need to update the menu to reflect state changes
void send_menuContents() {
  // send menu prompt
  parser.print(F("<bg n><w><+3>Control LinkIt Led via Bluetooth"));
  // send menu items
  parser.print(F("|A~<+6>LED is `"));
  parser.print(digitalRead(cmd_A_pin)); // read current output state 0 Low or 1 High
  parser.print(F("~~Off\\On")); // Note the \\ inside the "'s to send \ 
  // ============ end of menu item ===========
}

// ============= end generated code =========
