/**

 (c)2012 Forward Computing and Control Pty. Ltd.
 This code may be freely used for both private and commerical use.
 Provide this copyright is maintained.
 */

#include "pfodWaitForUtils.h"
#include "pfodParserUtils.h"


boolean pfodWaitForUtils::waitFor(const __FlashStringHelper *ifsh, Stream* input, Stream* output ) {
  const int MAX_LEN = 16;
  char str[MAX_LEN]; // allow for null
  getProgStr(ifsh, str, MAX_LEN);
  return waitFor((char*)str,input,output);
}

boolean pfodWaitForUtils::waitFor(const __FlashStringHelper *ifsh, int timeout, Stream* input, Stream* output ) {
  const int MAX_LEN = 16;
  char str[MAX_LEN]; // allow for null
  getProgStr(ifsh, str, MAX_LEN);
  return waitFor((char*)str, timeout,input,output);
}

boolean pfodWaitForUtils::waitForOK(Stream* input, Stream* output ) {
  return waitFor(F("OK"),input,output);
}

boolean pfodWaitForUtils::waitFor(const char* str, Stream* input, Stream* output ) {
  waitFor(str, 3000,input,output);
}

boolean pfodWaitForUtils::waitFor(const char* str, int timeout, Stream* input, Stream* output ) {
  size_t targetLen = 0;
  const char* target;
  size_t index = 0;
  target = str;
  targetLen = strlen(str);
  index = 0;
  long startTime = millis();
  if (targetLen == 0) {
    return true; // always matches
  }
  while (millis() - startTime < timeout) {
    // else
    if (input->available()) {
      char c = input->read();
      if (output) {
       output->print(c);
      } 
      if (c != target[index]) {
        index = 0; // reset index if any char does not match
      } // no else here
      if (c == target[index]) {
        //Serial.print("found "); Serial.write(c); Serial.print("index now"); Serial.println(index+1);
        if (++index >= targetLen) { // return true if all chars in the target match
          return true;
        }
      }
    }
  }
  return false; // timed out
}


// just dump chars from gprs to console until none found for 100mS
void pfodWaitForUtils::dumpReply(Stream* input, Stream* output) {
  long startTime = millis();
  const long timeout = 100;
  while (millis() - startTime < timeout) {
    if (input->available()) {
      char c = input->read();
      if (output) {
       output->print(c); // echo it
      }
      startTime = millis(); // reset start time
    }
  }
}

